<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'StructDomainCheckResponse' => '\\StructType\\StructDomainCheckResponse',
            'StructDomainList' => '\\StructType\\StructDomainList',
            'StructHostList' => '\\StructType\\StructHostList',
            'StructDSRecord' => '\\StructType\\StructDSRecord',
            'StructTld' => '\\StructType\\StructTld',
            'StructContact' => '\\StructType\\StructContact',
            'StructOwnerContact' => '\\StructType\\StructOwnerContact',
            'StructContactReturn' => '\\StructType\\StructContactReturn',
            'StructDomainInfo' => '\\StructType\\StructDomainInfo',
            'StructDomainTldInfo' => '\\StructType\\StructDomainTldInfo',
            'StructDomainPriceList' => '\\StructType\\StructDomainPriceList',
            'StructQueryOpeList' => '\\StructType\\StructQueryOpeList',
            'StructContactList' => '\\StructType\\StructContactList',
            'StructOptionsFwd' => '\\StructType\\StructOptionsFwd',
            'StructOptionsZone' => '\\StructType\\StructOptionsZone',
            'StructQueryZoneList' => '\\StructType\\StructQueryZoneList',
            'StructQueryMailFwdList' => '\\StructType\\StructQueryMailFwdList',
            'StructQueryWebFwdList' => '\\StructType\\StructQueryWebFwdList',
            'KeyValueData' => '\\StructType\\KeyValueData',
            'ArrayOfKeyValueData' => '\\ArrayType\\ArrayOfKeyValueData',
            'StructQueryResellerAccount' => '\\StructType\\StructQueryResellerAccount',
            'StructQueryOpePending' => '\\StructType\\StructQueryOpePending',
            'StructQueryDomainPrice' => '\\StructType\\StructQueryDomainPrice',
            'StructSessionInfo' => '\\StructType\\StructSessionInfo',
            'StructOperationResponse' => '\\StructType\\StructOperationResponse',
            'StructSSLInfo' => '\\StructType\\StructSSLInfo',
            'StructCSR' => '\\StructType\\StructCSR',
        );
    }
}
